SystemOrganization addCategory: #'PharoBot-UI'!

Object subclass: #PharoBotUIWithObjects
	instanceVariableNames: 'codeEditorText tabGroup workspacesTabGroup builder environment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoBot-UI'!

PharoBotUIWithObjects subclass: #PharoBotUIWithClasses
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoBot-UI'!

!PharoBotUIWithClasses methodsFor: 'ui building' stamp: 'NahuelGarbezza 2/11/2012 17:22'!
buildLayoutFor: browser
	
	browser
		row: [ :row | row column: #classes span: 30; column: #methods span: 70 ];
		row: #code.! !

!PharoBotUIWithClasses methodsFor: 'ui building' stamp: 'NahuelGarbezza 2/11/2012 17:23'!
buildTransitionsFor: browser
	
	browser transmit to: #classes; andShow: [ :p |
		p list
			title: 'Clases'; display: #classes;
			act: [ self createNewClass ] icon: GLMUIThemeExtraIcons glamorousAdd entitled: 'Nueva Clase';
			selectionAct: [ :class | self removeClass: class ] icon: GLMUIThemeExtraIcons glamorousRemove entitled: 'Eliminar Clase';
			act: [ self importClass ] icon: GLMUIThemeExtraIcons glamorousUp entitled: 'Importar Clase';
			selectionAct: [ :class | self exportClass: class ] icon: GLMUIThemeExtraIcons glamorousDown entitled: 'Exportar Clase'
	].
	browser transmit from: #classes; to: #methods; andShow: [ :p |
		p list
			title: 'Metodos de instancia'; display: [ :class | class selectors ];
			act: [ :m | nil ] icon: GLMUIThemeExtraIcons glamorousAdd entitled: 'Agregar metodo';
			selectionAct: [ :m | nil ] icon: GLMUIThemeExtraIcons glamorousRemove entitled: 'Eliminar metodo'.
		p list
			title: 'Metodos de clase'; display: [ :class | class class selectors ];
			act: [ :m | nil ] icon: GLMUIThemeExtraIcons glamorousAdd entitled: 'Agregar metodo';
			selectionAct: [ :m | nil ] icon: GLMUIThemeExtraIcons glamorousRemove entitled: 'Eliminar metodo'.
	].
	browser transmit
		from: #classes;
		from: #methods;
		to: #code;
		andShow: [ :p | 
			p smalltalkCode
				display: [ :class :selector |
					[ class >> selector ] on: Error do: [ class class >> selector ]
				];
				title: 'Implementacion';
				smalltalkClass: [ :class :selector | class ];
				act: [ :text | text inspect ] icon: GLMUIThemeExtraIcons glamorousCancel on: $l entitled: 'Deshacer cambios';
				act: [ :text | text inspect ] icon: GLMUIThemeExtraIcons glamorousAccept on: $s entitled: 'Guardar metodo'.
		].! !

!PharoBotUIWithClasses methodsFor: 'accessing' stamp: 'NahuelGarbezza 2/11/2012 17:24'!
environmentClass

	^PharoBotEnvironmentWithClasses! !

!PharoBotUIWithObjects class methodsFor: 'ui opening' stamp: 'NahuelGarbezza 2/11/2012 09:04'!
open

	^self new open! !

!PharoBotUIWithObjects methodsFor: 'ui building' stamp: 'NahuelGarbezza 2/27/2012 11:22'!
buildCodeBrowserLabel

	^builder newRow: {
		builder newImage: ThemeIcons projectIcon.
		builder newLabel: 'Codigo'.
	}! !

!PharoBotUIWithObjects methodsFor: 'ui building' stamp: 'NahuelGarbezza 2/11/2012 17:28'!
buildCodeBrowserPanel

	|browser|
	browser := GLMTabulator new.
	self buildLayoutFor: browser.
	self buildTransitionsFor: browser.
	^self startBrowser: browser.! !

!PharoBotUIWithObjects methodsFor: 'ui building' stamp: 'NahuelGarbezza 2/11/2012 17:30'!
buildLayoutFor: browser

	browser row: #instanceMethods span: 4; row: #code span: 6! !

!PharoBotUIWithObjects methodsFor: 'ui building' stamp: 'NahuelGarbezza 1/20/2012 10:04'!
buildMainButtons

	^builder newRow: {
		builder
			newButtonFor: self
			action: #saveImage
			label: 'Guardar Ambiente'
			help: 'Guarda el estado del ambiente para ser cargado luego'.
		builder
			newButtonFor: self
			action: #quit
			label: 'Salir'
			help: 'Sale del ambiente'.
	}.! !

!PharoBotUIWithObjects methodsFor: 'ui building' stamp: 'NahuelGarbezza 2/11/2012 17:26'!
buildMainPanel

	^(builder := UITheme builder) newColumn: {
		self buildMainTabGroup.
		self buildMainButtons.
	}.! !

!PharoBotUIWithObjects methodsFor: 'ui building' stamp: 'NahuelGarbezza 2/11/2012 17:26'!
buildMainTabGroup

	^builder newTabGroup: {
		self buildWorkspaceLabel -> self buildWorkspacePanel.
		self buildCodeBrowserLabel -> self buildCodeBrowserPanel.
	}.! !

!PharoBotUIWithObjects methodsFor: 'ui building' stamp: 'NahuelGarbezza 2/27/2012 11:25'!
buildTransitionsFor: browser

	browser transmit to: #instanceMethods; andShow: [ :p |
		p list
			title: 'Metodos';
			display: #robotMethods;
			selectionAct: [ :m | self removeInstanceMethod: m onClass: self environment robotClass ]
			icon: GLMUIThemeExtraIcons glamorousRemove
			entitled: 'Eliminar metodo'.
	].

	browser transmit from: #instanceMethods; to: #code; andShow: [ :p | 
		p smalltalkCode
			display: [ :selector | self environment robotClass >> selector ];
			title: 'Implementacion';
			smalltalkClass: self environment robotClass;
			act: [ :text | text inspect ]
			icon: GLMUIThemeExtraIcons glamorousCancel
			on: $l entitled: 'Cancelar';
			act: [ :text | text inspect ]
			icon: GLMUIThemeExtraIcons glamorousAccept
			on: $s entitled: 'Aceptar'.
		].! !

!PharoBotUIWithObjects methodsFor: 'ui building' stamp: 'NahuelGarbezza 2/27/2012 11:24'!
buildWorkspaceLabel

	^builder newRow: {
		builder newImage: ThemeIcons objectsIcon.
		builder newLabel: 'Pruebas'.
	}! !

!PharoBotUIWithObjects methodsFor: 'ui building' stamp: 'NahuelGarbezza 2/11/2012 19:05'!
buildWorkspacePanel

	|browser|
	browser := GLMTabulator new.
	browser
		row: #world span: 6;
		row: [ :row | row
			column: #workspaces span: 2;
			column: #currentWorkspace span: 5;
			column: #variables span: 3.
		] span: 4.
	
	browser transmit to: #world; andShow: [ :p |
		p morph display: [
			PanelMorph new
				layoutPolicy: ProportionalLayout new;
				hResizing: #spaceFill;
				vResizing: #spaceFill;
				addMorph: self buildWorldArea
		]
	].
	
	browser transmit to: #workspaces; andShow: [ :p |
		p list
			title: 'Workspaces';
			display: #workspaces;
			act: [ :pl | pl halt ] icon: GLMUIThemeExtraIcons glamorousAdd entitled: 'Nuevo Workspace';
			selectionAct: [ :w | nil ] entitled: 'Eliminar Workspace'
	].
	
	browser transmit from: #workspaces; to: #currentWorkspace; andShow: [ :p |
		p smalltalkCode title: #title; display: #content
	].
	
	browser transmit
		from: #workspaces;
		to: #variables;
		andShow: [ :p | p table
			display: [ :w | w variableBindings associations ];
			column: 'Variable' evaluated: #key;
			column: 'Valor' evaluated: #value;
			selectionAct: [ :t | t selection value inspect ] on: $i entitled: 'Inspect'
		].
		
	^self startBrowser: browser! !

!PharoBotUIWithObjects methodsFor: 'ui building' stamp: 'NahuelGarbezza 2/27/2012 11:17'!
buildWorldArea

	"TODO - Integrar codigo de Ariel"
	^Morph new! !

!PharoBotUIWithObjects methodsFor: 'actions' stamp: 'NahuelGarbezza 2/10/2012 23:31'!
createNewClass

	self shouldBeImplemented.! !

!PharoBotUIWithObjects methodsFor: 'accessing' stamp: 'NahuelGarbezza 2/27/2012 11:25'!
environment

	^environment! !

!PharoBotUIWithObjects methodsFor: 'accessing' stamp: 'NahuelGarbezza 2/11/2012 17:24'!
environmentClass

	^PharoBotEnvironmentWithObjects! !

!PharoBotUIWithObjects methodsFor: 'ui opening' stamp: 'NahuelGarbezza 2/27/2012 11:22'!
open

	environment := self environmentClass new.
	^(self buildMainPanel openInWindowLabeled: 'PharoBot') fullScreen; yourself! !

!PharoBotUIWithObjects methodsFor: 'actions' stamp: 'NahuelGarbezza 2/10/2012 23:32'!
removeClass: aClass

	self shouldBeImplemented.! !

!PharoBotUIWithObjects methodsFor: 'private' stamp: 'NahuelGarbezza 2/27/2012 11:25'!
startBrowser: browser

	^(browser startOn: self environment)
		renderGlamorouslyOn: PharoBotMorphicRenderer new! !
